/* 
   ѱ  ǥ ̺귯

     Ϸ մϴ.
 */
/* TODO 
   2004/07/19	LOOK_UP Լ ϼؾ.  */

#include <stdio.h>
#include <stdarg.h>
#include "hre.h"
#include "hlib.h"
#include "mslib.h"
#include "lexical.h"
#include "debug.h"

/* Ľ ̺
   Yacc    ǥ ǥ ְ , ٸ  ̽  ,
   ̷ Ľ ̺      ȿ̶  Ͽ ̷
   ۼϿ.
 
    ڿ ǹ̴ Lexer   ؼ  token  ǹϸ, X  Ǿ ִ 
     ó   κԴϴ.

    迭 ̴ stack_tag  ̿ ݵ ƾ Ѵ.  ̺ 迭 ̸
     ݵ hre.h  stack_tag  .  */
const char *hre_action[10] = {
/* 0         1
   012345678901234567890
   .()+*|&a[]^$\/-.{}:,?  */
  "EXXX*|X&&XXXXXXXXXXXX",  /* 0 RULE:          -> ǥ $ */
  "XXXXXXXXXXXXXXXXXXXXX",  /* 1 PAR:   ǥ  -> '(' ǥ $ ')'    */
  "XXXXXXXXXXXXXXXXXXXXX",  /* 2 LPAR:  ǥ  -> '{' ǥ $ '}'    */
  "XXXXXXX|X]XXXXXXXXXXX",  /* 3 OPT:   ǥ  -> '[' ǥ $ ']'    */
  "vXXXX|XvXvXXXXXXXXXXX",  /* 4 OR:    ǥ  -> ǥ '|' ǥ $    */
  "XXXXXXXXXXXXXXXXXXXXX",  /* 5 BAR:   ǥ  -> ǥ '-' ǥ $    */
  "XXXXXXXXXXXXXXXXXXXXX",  /* 6 CORON: ǥ  -> ǥ ':' ǥ $    */
  "XXXXXXXXXXXXXXXXXXXXX",  /* 7 COMMA: ǥ  -> ǥ ',' ǥ $    */
  "cXXX*cX&XXXXXXXXXXXXX",  /* 8 AND:   ǥ  -> ǥ ǥ $        */
  "XXXXXXXXXXXXXXXXXXXXX"   /* 9 SSAC:  ǥ  -> ^ ǥ $  */
};

/* Լ ڰ   , Լ ̸ ڿ ٴ´.  */
#define ATTRIBUTE_UNUSED

/*  ޼ ѷִ ƾ.  */
void
hre_error (char *fmt, ...)
{
  va_list ap;
  
  va_start (ap, fmt);
  vfprintf (stderr, fmt, ap);
  va_end (ap);
}

/*  ǥ óϱ  ʱȭ ʿ   ɿ  ʱȭ 
   Ѵ.  */
void
hre_init (void)
{
  /*  ƹϵ  ʴ´.  */
}

/* ϳ token  ؼ , ׿ ´  TOKEN  ϰ Ǹ,
   ؼ lexical token number  ȯϰ ȴ.  */
int
hre_lexer1 (token)
     struct hre_token *token;
{
  char *str;
  char ch;

  str = TOKEN_NAME (token);
  ch = str[0];

  /* ѱ ƴϰ,  +  + ȣ , SWITCH  ؼ ó ϰ ȴ.  */     
  switch (ch) 
    {
    case 0x0:
      TOKEN_TYPE (token) = END_T;
      return END_T;

    case 'a': case 'b': case 'c': case 'd': case 'e': case 'f':
    case 'g': case 'h': case 'i': case 'j': case 'k': case 'l':
    case 'm': case 'n': case 'o': case 'p': case 'q': case 'r':
    case 's': case 't': case 'u': case 'v': case 'w': case 'x':
    case 'y': case 'z':
    case 'A': case 'B': case 'C': case 'D': case 'E': case 'F':
    case 'G': case 'H': case 'I': case 'J': case 'K': case 'L':
    case 'M': case 'N': case 'O': case 'P': case 'Q': case 'R':
    case 'S': case 'T': case 'U': case 'V': case 'W': case 'X':
    case 'Y': case 'Z':
      TOKEN_TYPE (token) = IDENTIFIER_T;
      TOKEN_LEN (token) = 1;

      return IDENTIFIER_T;
    case '[':
      /*  [ ~ ] ǥ ̹Ƿ Ÿڴ ״
	 ϳ ڷ ν ǰ մϴ. */
      TOKEN_TYPE (token) = LEFT_BRAC_T;
      TOKEN_LEN (token) = 1;

      return LEFT_BRAC_T;
    case ']':
      TOKEN_TYPE (token) = RIGHT_BRAC_T;
      TOKEN_LEN (token) = 1;

      return RIGHT_BRAC_T;
    case '|':
      TOKEN_TYPE (token) = OR_T;
      TOKEN_LEN (token) = 1;

      return OR_T;
    case '*':
      TOKEN_TYPE (token) = STAR_T;
      TOKEN_LEN (token) = 1;

      return STAR_T;
    }

  /* ڿ +  + ȣ ,   ó ǰ Ǹ, ش token 
     ȯǰ Ǵµ, ⿡ ߴٴ  ó ( ó ϴ) 
     ̰ų, ѱ ̴.

     ѱ , ڵ Ȥ ϼ,    , ̰ ѱ
     ƴ ȮϿ ؼ θ ǴѴ.  ( ߿  ѱ Byte
      ̴.)  */
  TOKEN_LEN (token) = hre_ishangeul (str);
  if (TOKEN_LEN (token))
    {
      TOKEN_TYPE (token) = IDENTIFIER_T;
      return IDENTIFIER_T;
    }
  hre_error ("lexer  ó Ǿ ϴ ڰ Ѵ.");
}

/* HRE_TOKEN  Ʈ Ѵ.  */
void
update_hre_token (t)
     struct hre_token *t;
{
  TOKEN_TYPE (t) = -1;
  if (TOKEN_LEN (t))
    TOKEN_NAME (t) = TOKEN_NAME (t) + TOKEN_LEN (t);
  TOKEN_INDEX (t) = -1;
  TOKEN_LEN (t) = 0;
  TOKEN_NEXT (t) = NULL;
}

/* HRE_TREE  TOKENS   ؼ token  Ѵ.  */
void
insert_hre_token (token)
     struct hre_token *token;
{
  struct hre_token *t = (struct hre_token *) malloc (sizeof (struct hre_token) + 1);

  TOKEN_TYPE (t) = TOKEN_TYPE (token);
  TOKEN_NAME (t) = TOKEN_NAME (token);
  TOKEN_LEN (t) = TOKEN_LEN (token);
  TOKEN_PARENT (t) = TOKEN_PARENT (token);
  TOKEN_NEXT (t) = TOKEN_NEXT (token);
  if (TOKEN_PARENT (token) && TREE_TOKENS (TOKEN_PARENT (token)) != NULL) 
    {
      TOKEN_NEXT (t) = TREE_TOKENS (TOKEN_PARENT (token));
      TOKEN_INDEX (t) = TOKEN_INDEX (TREE_TOKENS (TOKEN_PARENT (token))) + 1;
    }
  TREE_TOKENS (TOKEN_PARENT (token)) = t;
}

/*  ǥ lexer. */
int
hre_lexer (token)
     struct hre_token *token;
{
  int tok;
  
  /* Token  ̹ տ ؼ   .  */
  if (TOKEN_NAME (token) && TOKEN_LEN (token))
    {
      /* Lexer  óϱ ռ,  token  ؾ  ʿ伺 ִµ,
	 ߿   ִ debugging ۾  ǵ ϱ ؼ 
	 ̴.  */
      insert_hre_token (token);
      update_hre_token (token);
    }

  tok = hre_lexer1 (token);

  return tok;
}

/* ڿ S   hash    ȯѴ.  hash  ̿ϴ 
   ߺǴ ڸ ִ ̰, DAG  ϱ ؼ̴.  */
unsigned char
hre_strhash(s)
     char *s;
{
  int h;
  char * t;

  for (h = 0, t = s; *t != '\0'; t++)
    h = ( h << 1 ) ^ *t;

  return (h & 0xff);
}

/*  ʿ.  */
int
hre_dup (int a, int b)
{
  long l, s;
  s = a + b;
  if (s < HASH_MAX)
    l = s*(s + 1)/2 + a;
  else
    {
      s = 2*(HASH_MAX - 1) - s;
      a = HASH_MAX - 1 -a;
      l = s*(s + 1)/2 + a;
      l = HASH_MAX*HASH_MAX - 1 - l;
    }

  return (int)(l/HASH_MAX);
}

/* TOKEN  ش ڿ  , ׿ ´ ڿ Ѵ.  */
char *
hre_copystr (token)
     struct hre_token * token;
{
  char * ret = (char *) malloc (TOKEN_LEN (token) + 1);

  strncpy (ret, TOKEN_NAME (token), TOKEN_LEN (token));
  ret[TOKEN_LEN (token)] = '\0';

  return ret;
}

/* ɺ ̺  ɺ , ˻ؼ ɺ ̺  ʴ´ٸ ߰ϰ
   ȴ.  ߺǴ IDENTIFIER  ν DAG  ϰ ȴ.  */
struct symbol *
hre_lookup (info, token)
     struct hre_tree * info;
     struct hre_token * token;
{
  char *s = hre_copystr (token);
  struct symbol * sym;
  unsigned char h;
  
  for (h = hre_strhash(s), sym = TREE_HASHTAB_N (info, h); sym != 0; sym = SYM_NEXT (sym))
    {
      if ( strcmp(SYM_NAME (sym), s) == 0)
	{
	  free (s);
	  return sym;
	}
    }
  
  sym = (struct symbol *) malloc (sizeof (*sym));
  SYM_NAME (sym) = xstrdup (s);
  SYM_HASH (sym) = h;
  SYM_LENGTH (sym) = TOKEN_LEN (token);
  SYM_NEXT (sym) = TREE_HASHTAB_N (info, h);
  TREE_HASHTAB_N (info, h) = sym;
  SYM_TAIL (sym) = NULL;
  if (TREE_FIRST_B (info) == 0)
    TREE_FIRST_B (info) = sym;
  else
    SYM_TAIL (TREE_LAST_B (info)) = sym;

  TREE_LAST_B (info) = sym;
  free (s);
  return sym;
}

/* Parser   ؼ    Ǵ hre_tree ü Ҵϰ
   ʱȭѴ.  ʱȭǰ Ҵ ü ͸ ȯѴ.  */
struct hre_tree *
init_hre_tree (void)
{
  int i;
  struct hre_tree * info = (struct hre_tree *) malloc (sizeof (struct hre_tree) + 1);

  /* HRE_TREE  ʱȭ.  */
  TREE_SP (info) = TREE_STACK (info);

  TREE_FIRST_B (info) = NULL;
  TREE_LAST_B (info) = NULL;

  TREE_TOKENS (info) = NULL;

  TREE_EQU_TAB (info) = NULL;
  TREE_EQUS (info) = 0;
  TREE_T_EQUS (info) = 0;
  TREE_EQU_MAX (info) = 0;

  TREE_X_STACK(info) = 0;
  TREE_X_S(info) = 0;
  TREE_X_MAX(info) = 0;

  for (i=0; i<EXP_MAX; i++)
    TREE_EXP_HASH_N (info, i) = 0;

  return info;
}

/*  ÿ TAG  ϰ ȴ.
   hre_action  stack_tag   踦 .  */
void
hre_push (info, tag, q)
     struct hre_tree *info;
     stack_tag tag;
     int q;
{
  if (TREE_SP (info) >= TREE_STACK (info) + STACK_MAX)
    hre_error ("ǥ  ִ ũ⸦ Ѵ±.");

  STACK_TAG (TREE_SP (info)) = tag;
  STACK_Q (TREE_SP (info)) = q;
  TREE_SP (info)++;
}

/*  NODE   ǥ ۼѴ.  ۼ ǥ INFO  equation ü 
   equ_tab  Q ° ׸  ȴ.  */
int
hre_make_exp (struct hre_tree *info, int q, exp_tag tag, ...)
{
  va_list ap;
  struct symbol *sym;
  struct exp *hp, *e;
  unsigned char args;
  int h, q0, q1;

  va_start(ap, tag);
  switch (tag)
    {
    case SYM_X:
      sym = va_arg (ap, struct symbol *);
      h = 0x100 + SYM_HASH (sym);
      args = 0;
      for (hp = TREE_EXP_HASH_N (info, h); hp != 0; hp = EXP_TAIL (hp))
	{
	  if ( sym == EXP_BODY_LEAF (hp))
	    {
	      if ( q != -1 && q != EXP_CLASS (hp))
		EQU_VALUE (TREE_EQU_TAB_N (info, q)) = hp;
	      return EXP_CLASS (hp);
	    }
	}
      break;
    case AND_X:
      q0 = va_arg (ap, int);
      q1 = va_arg (ap, int);
      /* ؽ  : 0x80 + (0x0 ~ 0x40) */
      h = 0x80 + hre_dup (EQU_HASH (TREE_EQU_TAB_N(info, q0)), 
			  EQU_HASH (TREE_EQU_TAB_N(info, q1))) / 4;
      args = 2;
      for (hp = TREE_EXP_HASH_N (info, h); hp != 0; hp = EXP_TAIL (hp))
	{
	  if (q0 == EXP_BODY_ARG_N (hp, 0) && q1 == EXP_BODY_ARG_N (hp, 1))
	    {
	      if (q != -1 && q != EXP_CLASS (hp))
		EQU_VALUE (TREE_EQU_TAB_N (info, q)) = hp;
	      return EXP_CLASS (hp);
	    }
	}
      break;
    case OR_X:
      q0 = va_arg (ap, int);
      q1 = va_arg (ap, int);
      /* ؽ  : 0x40 + (0x0 ~ 0x20) */
      h = 0x40 + hre_dup (EQU_HASH (TREE_EQU_TAB_N(info, q0)), 
			  EQU_HASH (TREE_EQU_TAB_N(info, q1))) / 8;
      args = 2;
      for (hp = TREE_EXP_HASH_N (info, h); hp != 0; hp = EXP_TAIL (hp))
	{
	  if (q0 == EXP_BODY_ARG_N (hp, 0) && q1 == EXP_BODY_ARG_N (hp, 1))
	    {
	      if (q != -1 && q != EXP_CLASS (hp))
		EQU_VALUE (TREE_EQU_TAB_N (info, q)) = hp;
	      return EXP_CLASS (hp);
	    }
	}
      break;
    case ZERO_X:
    case ONE_X:
      /* ZERO_X -> ؽ  : 0x0 */
      /* ONE_X -> ؽ  : 0x1 */
      h = (tag == ZERO_X) ? 0 : 1;
      args = 0;
      hp = TREE_EXP_HASH_N (info, h);
      if (hp != 0)
	{
	  if (q != -1 && q != EXP_CLASS (hp))
	    EQU_VALUE (TREE_EQU_TAB_N (info, q)) = hp;
	  return EXP_CLASS (hp);
	}
      break;
    case STAR_X:
    case PLUS_X:
      q0 = va_arg (ap, int);
      /* ؽ  : 0x0c + (0x0 ~ 0x14 */
      if (tag == STAR_X)
	h = 0x0c + EQU_HASH (TREE_EQU_TAB_N(info, q0))*0x14 / 0x200;
      else if (tag == PLUS_X)
	h = 0x02 + EQU_HASH (TREE_EQU_TAB_N(info, q0))*0x0a / 0x200;
      args = 1;
      for (hp = TREE_EXP_HASH_N (info, h); hp != 0; hp = EXP_TAIL (hp))
	{
	  if (q0 == EXP_BODY_ARG_N (hp, 0))
	    {
	      if (q != -1 && q != EXP_CLASS (hp))
		EQU_VALUE (TREE_EQU_TAB_N (info, q)) = hp;
	      return EXP_CLASS (hp);
	    }
	}
      break;
    default:
      hre_error (" ó մϴ.");
    }
  va_end (ap);

  e = (struct exp *) malloc (sizeof (*e));
  EXP_TAG (e) = tag;
  EXP_ARGS (e) = args;

  if (tag == SYM_X)
    EXP_BODY_LEAF (e) = sym;
  else
    {
      EXP_BODY_ARG (e) = (int *) (args > 0 ? malloc (args*sizeof (int)) : 0 );
      if (args > 0) EXP_BODY_ARG_N(e, 0) = q0;
      if (args > 1) EXP_BODY_ARG_N(e, 1) = q1;
    }

  EXP_HASH (e) = h;
  EXP_TAIL (e) = TREE_EXP_HASH_N (info, h);
  TREE_EXP_HASH_N (info, h) = e;

  if (q == -1)
    {
      if (TREE_EQUS (info) == TREE_EQU_MAX (info))
        {
          TREE_EQU_MAX (info) += EQU_EXTEND;
          TREE_EQU_TAB (info) =
	    (struct equation *) realloc (TREE_EQU_TAB (info),
					 sizeof (*TREE_EQU_TAB (info)) * TREE_EQU_MAX (info));
        } 
      EQU_HASH (TREE_EQU_TAB_N (info, TREE_EQUS (info))) = h;
      EQU_STACK (TREE_EQU_TAB_N (info, TREE_EQUS (info))) = 0;
      q = TREE_EQUS (info)++;
    }
  EQU_VALUE (TREE_EQU_TAB_N (info, q)) = e;
  EQU_INDEX (TREE_EQU_TAB_N (info, q)) = 100;
  
  EXP_CLASS (e) = q;

  TREE_EXP_FREE_N (info, TREE_T_EQUS (info)) = e;
  TREE_T_EQUS (info)++;

  return q;
}

/* hre.h Ͽ Ǿ ִ hre_action ̺    token
    TYPE   ö     ̵  ã´.  */
int
hre_change_action (info, token, rhs)
     struct hre_tree *info;
     struct hre_token *token;
     int *rhs;
{
  int last_token = TOKEN_TYPE (token);
  char ch = hre_action[TOP][TOKEN_TYPE (token)];

  switch (ch)
    {
    case '&':
      hre_push (info, AND, *rhs);
      hre_process_expression (info, token, rhs);
      break;
    case 'c':
      *rhs = hre_make_exp (info, -1, AND_X, POP (), *rhs);
      hre_change_action (info, token, rhs);
      break;
    case 'E':
      (void) POP ();
      return *rhs;
    case '|':
      hre_push (info, OR, *rhs);
      last_token = hre_lexer (token);
      hre_process_expression (info, token, rhs);
      break;
    case 'v':
      *rhs = hre_make_exp (info, -1, OR_X, POP (), *rhs);
      hre_change_action (info, token, rhs);
      break;
    case ']':
      (void) POP ();
      last_token = hre_lexer (token);
      hre_change_action (info, token, rhs);
      break;
    case '*':
      *rhs = hre_make_exp (info, -1, STAR_X, *rhs);
      last_token = hre_lexer (token);
      hre_change_action (info, token, rhs);
      break;
    default:
      hre_error ("ó ٶ, TOP = %d, LAST_TOKEN = %d\n", TOP, TOKEN_TYPE (token));
      abort ();
    }

  return -1;
}

void
hre_process_expression (info, token, rhs)
     struct hre_tree *info;
     struct hre_token *token;
     int *rhs;
{
  int last_token = TOKEN_TYPE (token);

  switch (last_token)
    {
    case IDENTIFIER_T:
      *rhs = hre_make_exp (info, -1, SYM_X, hre_lookup (info, token));
      last_token = hre_lexer (token);
      hre_change_action (info, token, rhs);
      break;
    case LEFT_BRAC_T:
      hre_push (info, OPT, -1);
      last_token = hre_lexer (token);
      hre_process_expression (info, token, rhs);
      break;
    default: 
      hre_error ("EXP 󺧿 ߸  ǥԴϴ.\n");
      abort ();
    }
}

/* struct hre_token  T  ʱȭϴµ,  Է  ǥ EXP  ڷ
    , װ ȴٴ  ٸ. */
void
init_hre_token_once (t, info, exp)
     struct hre_token *t;
     struct hre_tree * info;
     char *exp;
{
  TOKEN_TYPE (t) = -1;
  TOKEN_NAME (t) = exp;
  TOKEN_INDEX (t) = -1;
  TOKEN_PARENT (t) = info;
  TOKEN_LEN (t) = 0;
  TOKEN_NEXT (t) = NULL;
}

/* ڰ Է  ǥ ؼϿ,  TREE  ۼϿ
   ȯѴ.   TREE  ؼ  ǥ   Եǰ ȴ.  */
struct hre_tree *
hre_parser (exp, option)
     char * exp;
     int option ATTRIBUTE_UNUSED;
{
  struct symbol * ident;
  struct hre_tree * info;
  /* ͸  ʰ ̷   lexer  ȣ  
     hre_token    Ҵ ִ  ٶ   Ƽ
     ϳ token  ؼ Ϸ  ü 縦   ų ǵ
     Ͽ.  */
  struct hre_token t;
  int rhs;
  int last_token, last_index = 0;

  /* ü Ҵϰ ʱȭѴ.  */
  info = init_hre_tree ();
  /* Token   Ǵ  ʱȭѴ.  */
  init_hre_token_once (&t, info, exp);

  last_token = hre_lexer (&t);
  if (last_token == IDENTIFIER_T)
    {
      ident = hre_lookup (info, &t);
      last_token = hre_lexer (&t);
      hre_push (info, RULE, -1);
      rhs = hre_make_exp (info, -1, SYM_X, ident);
      TREE_LAST_RHS (info) = hre_change_action (info, &t, &rhs);
    }
  else
    hre_push (info, RULE, -1);

  TREE_LAST_RHS (info) = hre_change_action (info, &t, &rhs);

  return info;
}

/* Ƽ Ʈ  ó ؾ ϴµ, ƼƮ ó ϴ  Ʒ .
   ϼ  `Ȳ'  ,  ``ǥ'' ϳ ǥ Ÿ ִµ,

     E0 -> Ȳ

   ̸ ΰ CONCATENATION  ϴ ̴.  `Ȳ'  2 Ʈ (0xc8b2) ̹Ƿ
   Ʒ  ǥ Ѵ.

     E0 -> E1 & E2
         E1 -> 0xc8
	 E2 -> 0xb2
   
     ν, Ÿ  [ ... ]  Ǿ ִ ̺  
   DFA µ   ִ.    ̴ 2 Ʈ ̻  شȴ.  */
void
hre_apply_multi_form (p, last_rhs)
     struct hre_tree *p;
     int last_rhs;
{
  if (EQU_VALUE (TREE_EQU_TAB_N (p, last_rhs)))
    {
      int args = EXP_ARGS (EQU_VALUE (TREE_EQU_TAB_N (p, last_rhs)));
      if (args == 0 )
	{
	  int length = 
	    SYM_LENGTH (EXP_BODY_LEAF (EQU_VALUE (TREE_EQU_TAB_N (p, last_rhs))));
	  char *str =
	    SYM_NAME (EXP_BODY_LEAF (EQU_VALUE (TREE_EQU_TAB_N (p, last_rhs))));

	  /* IDENTIFIER ̰ 1  ũٴ  ѱ Ȥ Ƽ Ʈ ڶ ̴.

	     TODO : Ʒ ˰   ʿϴ.  */
	  if (length > 1)
	    {
	      int i, rhs = -1;
	      int ident[length];
	      int andt[length-1];

	      for (i=0; i<length; i++) 
		{
		  struct hre_token token, *t = &token;
		  TOKEN_TYPE (t) = IDENTIFIER_T;
		  TOKEN_NAME (t) = str+i;
		  TOKEN_LEN (t)  = 1;
		  ident[i] = hre_make_exp (p, -1, SYM_X, hre_lookup (p, t));
		}
	      for (i=0; i<length-1; i++)
		{
		  if (i == 0)
		    andt[i] = hre_make_exp (p, -1, AND_X, ident[i], ident[i+1]);
		  else
		    andt[i] = hre_make_exp (p, -1, AND_X, andt[i-1], ident[i+1]);
		}
	      hre_make_exp (p, last_rhs, OR_X, andt[i-1], hre_make_exp (p, -1, ZERO_X));
	    }
	}
      else if (args == 1 )
	  hre_apply_multi_form (p, 
				EXP_BODY_ARG_N (EQU_VALUE (TREE_EQU_TAB_N (p, last_rhs)), 
						0));
      else if (args == 2 )
	{
	  hre_apply_multi_form (p, 
				EXP_BODY_ARG_N (EQU_VALUE (TREE_EQU_TAB_N (p, last_rhs)), 
						0));
	  hre_apply_multi_form (p, 
				EXP_BODY_ARG_N (EQU_VALUE (TREE_EQU_TAB_N (p, last_rhs)), 
						1));
	}
    } 
}

/* ϳ ¸ Ѵ.  ⼭ ``'' DFA  ϳ ̺ ϴ
    ϸ, S_LIST  S_LIST_SIZE  hre_parser ()   ¿ 
   õǴ expression  ġ (ȮϰԴ ȣ) ȣ 迭  
   ִ.  */
int
hre_add_state (p, s_list_size, s_list)
     struct hre_tree * p;
     int s_list_size, *s_list;
{
  int d, i;
  struct state * dp;

  for (d = 0; d < TREE_STATE_S (p); d++)
    {
      dp = &TREE_STATE_TAB_N (p, d);
      if (s_list_size != STATE_S_LIST_SIZE_P (dp))
        continue;
      for (i = 0; i < s_list_size; i++)
        {
          if (s_list[i] != STATE_S_LIST_P_N (dp, i))
            break;
	}
      if (i >= s_list_size)
	return d;
    }
  if ((TREE_STATE_S (p) % 7) == 0)
    TREE_STATE_TAB (p) = 
      (struct state *) realloc (TREE_STATE_TAB (p),
				sizeof (struct state) * (TREE_STATE_S (p) + 8));
				  
  STATE_CLASS (TREE_STATE_TAB_N (p, TREE_STATE_S (p))) = TREE_STATE_S (p);
  STATE_S_LIST_SIZE (TREE_STATE_TAB_N (p, TREE_STATE_S (p))) = s_list_size;
  STATE_S_LIST (TREE_STATE_TAB_N (p, TREE_STATE_S (p))) = s_list;

  return TREE_STATE_S (p)++;
}

/*  ʿ */
void
hre_pushq (p, q)
     struct hre_tree *p;
     int q;
{
  if (EQU_STACK (TREE_EQU_TAB_N (p, q)))
    return;

  if (TREE_X_S (p) == TREE_X_MAX (p))
    {
      TREE_X_MAX (p) += X_EXTEND;
      TREE_X_STACK (p) = 
	(int *) realloc (TREE_X_STACK (p), sizeof (int) * TREE_X_MAX (p));
    }

  TREE_X_STACK_N (p, TREE_X_S (p)++) = q;
  EQU_STACK (TREE_EQU_TAB_N (p, q)) = 1;
}

/*  ʿ */
void
hre_popq (p)
     struct hre_tree *p;
{
  int q = TREE_X_STACK_N (p, --TREE_X_S (p));

  EQU_STACK (TREE_EQU_TAB_N (p, q)) = 0;
}

void
hre_add_buf (p, lhs, q)
     struct hre_tree *p;
     struct symbol * lhs;
     int q;
{
  int diff, i=0, j, s, t;
  struct item * ip;
  char * name;

  if (lhs == NULL)
    goto TO_DOT;

  name = SYM_NAME (lhs);
  for (i = 0; i < TREE_ITEM_S (p); i++)
    {
      diff = strcmp(SYM_NAME (ITEM_LHS (TREE_ITEM_BUF_N (p, i))), name);
      if (diff == 0)
        goto FOUND;
      if (diff > 0)
        break;
    }

TO_DOT:
  if (TREE_ITEM_S (p) >= TREE_ITEM_MAX (p))
    {
      TREE_ITEM_MAX (p) += 8;
      TREE_ITEM_BUF (p) = 
	(void *) realloc (TREE_ITEM_BUF (p), 
			  sizeof *TREE_ITEM_BUF (p) * TREE_ITEM_MAX (p));
    }

  for (j = TREE_ITEM_S (p)++; j > i; j--)
    TREE_ITEM_BUF_N (p, j) = TREE_ITEM_BUF_N (p, j - 1);
  
  ITEM_LHS (TREE_ITEM_BUF_N (p, i))  = lhs;
  ITEM_SIZE (TREE_ITEM_BUF_N (p, i)) = 0;
  ITEM_RHS (TREE_ITEM_BUF_N (p, i))  = 0;
  ITEM_INDEX (TREE_ITEM_BUF_N (p, i)) = 100;

FOUND:
  ip = &TREE_ITEM_BUF_N (p, i);
  for (s = 0; s < ITEM_SIZE_P (ip); s++)
  {
      if (ITEM_RHS_P_N (ip, s) == q)
        return;
      if (ITEM_RHS_P_N (ip, s) > q)
        break;
    }
  if ((ITEM_SIZE_P (ip) & 7) == 0)
    ITEM_RHS_P (ip) =
      (void *) realloc (ITEM_RHS_P (ip),
			sizeof *ITEM_RHS_P (ip) * (ITEM_SIZE_P (ip) + 8));
  for (t = ITEM_SIZE_P (ip)++; t > s; t--)
    ITEM_RHS_P_N (ip, t) = ITEM_RHS_P_N (ip, t - 1);
  ITEM_RHS_P_N (ip, s) = q;
}

/* hre_parser () Լ ؼ  ``ǥ''   DFA ̺ 
   ϱ   ǥĿ  ``µ''  Ѵ.  */
void
hre_form_state (p)
     struct hre_tree *p;
{
  int i, s, s1, x;
  struct state * sp;

  /* µ   Ǵ   ʱȭ ǽѴ.  */
  TREE_ITEM_BUF (p) = 0;
  TREE_ITEM_MAX (p) = 0;
  TREE_STATE_TAB (p) = 0;
  TREE_STATE_S (p) = 0;

  /*   level  ִ ǥĿ  ¸ 켱 Ѵ.   ϵ
       Ʒ  ƾ   ؼϰ Ǵ ̴.  */
  hre_add_state (p, 1, &TREE_LAST_RHS (p));
  for (s = 0; s < TREE_STATE_S (p); s++)
    {
      /*  ¿  ͸ 켱 ´.  */
      sp = & TREE_STATE_TAB_N (p, s);

      for (TREE_X_S (p) = 0, s1 = 0; s1 < STATE_S_LIST_SIZE_P (sp); s1++)
        hre_pushq (p, STATE_S_LIST_P_N (sp, s1));

      for (STATE_ACCEPT (sp) = 0, TREE_ITEM_S (p) = 0, x = 0; x < TREE_X_S (p); x++)
        {
	  int qx = TREE_X_STACK_N (p, x);
	  int q1, q2;
          struct exp * e;
	  
	EVALUATE:
	  e = EQU_VALUE (TREE_EQU_TAB_N (p, qx));
	  switch (EXP_TAG (e))
	    {
	    case ZERO_X:
	      break;
	    case ONE_X: 
	      /* Accept ̺  ʿ伺   */
	      STATE_ACCEPT (sp) = 1;
	      break;
	    case SYM_X:
	      /* ڿ ѱ ٸ , ٸ  ִٸ,   1 Ʈ̱ ,
		 Ƽ Ʈ  ߻Ǵ DFA   Ű  ʿ䰡 , 
		 Ƽ Ʈ , ڿ ٸ  ־ Ѵ.  */
	      hre_add_buf (p, EXP_BODY_LEAF (e), hre_make_exp (p, -1, ONE_X));
	      break;
	    case OR_X:
	      hre_pushq (p, EXP_BODY_ARG_N (e, 0));
	      hre_pushq (p, EXP_BODY_ARG_N (e, 1));
	      break;
	    case STAR_X:
	      q1 = EXP_BODY_ARG_N (e, 0);
	      hre_make_exp (p, qx, OR_X, 
			    hre_make_exp (p, -1, ONE_X), 
			    hre_make_exp (p, -1, PLUS_X, q1));
	      goto EVALUATE;
	    case PLUS_X:
	      q1 = EXP_BODY_ARG_N (e, 0);
	      hre_make_exp (p, qx, AND_X, q1, hre_make_exp (p, -1, STAR_X, q1));
	      goto EVALUATE;
	    case AND_X:
	      {
		int a, b;
		struct exp * e1;

		q1 = EXP_BODY_ARG_N (e, 0);
		q2 = EXP_BODY_ARG_N (e, 1);
		e1 = EQU_VALUE (TREE_EQU_TAB_N (p, q1));
		switch (EXP_TAG (e1))
		  {
		  case SYM_X:
		    hre_add_buf (p, EXP_BODY_LEAF (e1), q2);
		    break;
		  case AND_X:
		    a = EXP_BODY_ARG_N (e1, 0);
		    b = EXP_BODY_ARG_N (e1, 1);
		    hre_make_exp (p, qx, AND_X, a, hre_make_exp (p, -1, AND_X, b, q2));
		    goto EVALUATE;
		  case OR_X:
		    a = EXP_BODY_ARG_N (e1, 0);
		    b = EXP_BODY_ARG_N (e1, 1);
		    hre_make_exp (p, qx, OR_X, 
				  hre_make_exp (p, -1, AND_X, a, q2), 
				  hre_make_exp (p, -1, AND_X, b, q2));
		    goto EVALUATE;
		  case ZERO_X:
		    hre_make_exp (p, qx, ZERO_X);
		    break;
		  case STAR_X:
		    a = EXP_BODY_ARG_N (e1, 0);
		    hre_make_exp (p, qx, OR_X, q2, hre_make_exp (p, -1, AND_X, a, qx));
		    goto EVALUATE;
		    break;
		  default:
		    hre_error ("FORM :  %d  óؾ Ѵ.", EXP_TAG (e1));
		  }

		break;
	      }
	    default:
	      hre_error ("FORM : %d  óؾ Ѵ.", EXP_TAG (e));
	    }
	}
      while (TREE_X_S (p) > 0)
	hre_popq (p);

      STATE_SHIFTS (sp) = TREE_ITEM_S (p);
      STATE_SH_LIST (sp) = (void *) malloc (sizeof (struct state) * TREE_ITEM_S (p));

      /*  ؼ   ¿   ϰ Ǵµ, LHS   ¿
	 Է°   ִ ڵ鿡    ְ, RHS  ش ڰ
	   ̵ؾ ϴ DFA ̺ ȣ  ִ.  */
      for (i = 0; i < TREE_ITEM_S (p); i++)
	{
	  STATE_SH_LIST_N_LHS (sp, i) = ITEM_LHS (TREE_ITEM_BUF_N (p, i));
	  STATE_SH_LIST_N_RHS (sp, i) = 
	    hre_add_state (p, 
			  ITEM_SIZE (TREE_ITEM_BUF_N (p, i)), 
			  ITEM_RHS (TREE_ITEM_BUF_N (p, i)));
	}
    }
}

/*  ʿ */
void 
hre_add_equiv (p, L, R)
     struct hre_tree *p;
     int L;
     int R;
{
  int e;
  struct state * sL, * sR;

  L = STATE_CLASS (TREE_STATE_TAB_N (p, L));
  R = STATE_CLASS (TREE_STATE_TAB_N (p, R));

  if (L == R)
    return;
  if (L > R)
    L ^= R, R ^= L, L ^= R;

  sL = &TREE_STATE_TAB_N (p, L);
  sR = &TREE_STATE_TAB_N (p, R);

  for (e = 0; e < TREE_EQUIV_S (p); e++)
    {
      if (sL == EQUIV_L (TREE_EQUIV_TAB_N (p, e)) 
	  && sR == EQUIV_R (TREE_EQUIV_TAB_N (p, e)))
        return;
    }

  if (TREE_EQUIV_S (p) >= TREE_EQUIV_MAX (p))
    {
      TREE_EQUIV_MAX (p) += 8;
      TREE_EQUIV_TAB (p) = 
	(void *) realloc (TREE_EQUIV_TAB (p), 
			  sizeof *TREE_EQUIV_TAB (p) * TREE_EQUIV_MAX (p));
    }

  EQUIV_L (TREE_EQUIV_TAB_N (p, TREE_EQUIV_S (p))) = sL;
  EQUIV_R (TREE_EQUIV_TAB_N (p, TREE_EQUIV_S (p))) = sR;
  
  TREE_EQUIV_S (p)++;
}

/*  ʿ */
void 
hre_merge_states (p)
     struct hre_tree *p;
{
  int classes, s, s1, e, sh;
  struct state * sp, * sp1, * qL, * qR;

  TREE_EQUIV_TAB (p) = 0;
  TREE_EQUIV_MAX (p) = 0;
  
  for (s = 0; s < TREE_STATE_S (p); s++)
    {
      sp = &TREE_STATE_TAB_N (p, s);
      if (STATE_CLASS_P (sp) != s)
	continue;
      for (s1 = 0; s1 < s; s1++)
        {
          sp1 = &TREE_STATE_TAB_N (p, s1);
          if (STATE_CLASS_P (sp1) != s1)
	    continue;
          TREE_EQUIV_S (p) = 0, hre_add_equiv(p, s, s1);
          for (e = 0; e < TREE_EQUIV_S (p); e++) {
            qL = EQUIV_L (TREE_EQUIV_TAB_N (p, e));
	    qR = EQUIV_R (TREE_EQUIV_TAB_N (p, e));
            if (STATE_ACCEPT (qL) != STATE_ACCEPT (qR) 
		|| STATE_SHIFTS (qL) != STATE_SHIFTS (qR))
              goto NOT_EQUAL;
            for (sh = 0; sh < STATE_SHIFTS (qL); sh++)
              if (STATE_SH_LIST_N_LHS (qL, sh) != STATE_SH_LIST_N_LHS (qR, sh))
                goto NOT_EQUAL;
            for (sh = 0; sh < STATE_SHIFTS (qL); sh++)
              hre_add_equiv (p, STATE_SH_LIST_N_RHS (qL, sh), STATE_SH_LIST_N_RHS (qR, sh));
          }
EQUAL: break;
NOT_EQUAL: continue;
        }
      if (s1 < s)
	{
          for (e = 0; e < TREE_EQUIV_S (p); e++)
	    {
              struct state * qL = EQUIV_L (TREE_EQUIV_TAB_N (p, e));
	      struct state * qR = EQUIV_R (TREE_EQUIV_TAB_N (p, e));
              STATE_CLASS_P (qR) = STATE_CLASS_P (qL);
            }
	}
    }

    for (classes = 0, s = 0; s < TREE_STATE_S (p); s++) 
      {
       sp = &TREE_STATE_TAB_N (p, s);
        STATE_CLASS_P (sp) = 
	  (STATE_CLASS_P (sp) == s) ? classes++ 
	  : STATE_CLASS (TREE_STATE_TAB_N (p, STATE_CLASS_P (sp)));
      }
}

/* տ ϼ DFA µ   DFA ̺ ϰ ȴ.  */
void
hre_write_states (p, ret)
     struct hre_tree *p;
     struct hdfa *ret;
{
  int i, s, sh, classes;
  struct state *sp;

  HDFA_INDEX (ret) = TREE_STATE_S (p);

  /* տ ȹ   DFA ̺   켱 ҴѴ.  */
  HDFA_TABLE (ret) = (int **) malloc (sizeof (int *) * TREE_STATE_S (p));
  for (s = classes = 0; s < TREE_STATE_S (p); s++)
    {
      int *ip;

      sp = &TREE_STATE_TAB_N (p, s);

      if (STATE_CLASS_P (sp) != classes)
	continue;

      classes++;

      /* µ   ҴѴ.  */
      HDFA_TABLE_N (ret, s) = (int *) malloc (sizeof (int) * 256);
      ip = HDFA_TABLE_N (ret, s);

      if (STATE_ACCEPT (sp))
	{
	  /*   ° accept  , 켱 ش ̺ -2  ä 
	     Ѵ.  ̺ -2  accept ǹ̸  -1  и ǹѴ.
	     0  ū  ش ¸ Ѵ.  */
	  for (i = 0; i<256; i++)
	    ip[i] = -2;
	}
      else
	  for (i = 0; i<256; i++)
	    ip[i] = -1;

      for (sh=0; sh < STATE_SHIFTS (sp); sh++)
	{
	  int lhs = ((int) SYM_NAME (STATE_SH_LIST_N_LHS (sp, sh))[0]) & 0xff;
	  int rhs = STATE_SH_LIST_N_RHS (sp, sh);
	  ip[lhs] = rhs;
	}
    }
}

/* DFA ̺  ؼ ݱ ȰϿ  ޸𸮸  Ѵ.  */
void
hre_front_free (p)
     struct hre_tree *p;
{
  int i;
  struct hre_token *n, *t = TREE_TOKENS (p);
  struct symbol *st, *s = TREE_FIRST_B (p);
  struct state *sp;

  /* ū  free */
  while (t)
    {
      n = t->next;
      free (t);
      t = n;
    }
  /* ɺ  free */
  while (s)
    {
      st = s->tail;
      free (s->name);
      free (s);
      s = st;
    }
  /* state  free */
  for (i=0; i<TREE_STATE_S (p); i++)
    {
      sp = & TREE_STATE_TAB_N (p, i);
      free (STATE_SH_LIST (sp));
    }

  /* exp ü  free */
  for (i=0; i<TREE_T_EQUS (p); i++) 
    {
      struct exp *e = TREE_EXP_FREE_N (p, i);
      if (EXP_TAG (e) != SYM_X && EXP_ARGS (e) > 0)
	free (TREE_EXP_FREE_N (p, i));
      free (TREE_EXP_FREE_N (p, i));
    }
  free (p);
}

/* ڰ Է  ǥ ؼϿ, DFA ̺ Ͽ
   ȯѴ.  */
hre_t
hre_compile (exp, option)
     char * exp;
     struct hre_options option;
{
  struct hre_tree *parsed;
  hre_t ret = (hre_t) malloc (sizeof (struct hdfa) + 1);

  HDFA_RE (ret) = exp;

  /*  ǥ óϱ  ʱȭ ʿ  óѴ.  */
  hre_init ();

  /* ``ǥ''  Ѵ.  */
  parsed = hre_parser (exp, option);
  if (TREE_LAST_RHS (parsed) == -1)
    {
      hre_error ("Խ м   Ͽϴ.\n");
      abort ();
    }

  /*   ``ǥ''  , ѱ۰  ƼƮ ó ؼ
      ǥĿ   ؾ Ѵ.  */
  hre_apply_multi_form (parsed, TREE_LAST_RHS (parsed));
  
  /*   ``ǥ''  , ``µ'' Ѵ.  */
  hre_form_state (parsed);

  /* ``µ'' merging  ̷  ִ  ģ.  */
  hre_merge_states (parsed);

  /* ``µ''  DFA ̺ RET  Ѵ.  */
  hre_write_states (parsed, ret);

  /* DFA ̺ ϸ鼭 Ͽ  ޸𸮸 Ѵ.  */
  hre_front_free (parsed);

  return ret;
}

/* hre_compile () Լ   DFA ̺  ڰ 
   ڿ ش  ã´.  ã , ش  ߰ߵ  
   ġ ȯѴ.  ã   -1  ȯѴ.  */
int
hre_search (dfa, str)
     hre_t dfa;
     const char *str;
{
  int s = 0, i = 0, c, p = 0;
  int **t = dfa->table;
  
  while (c = (((int) str[i]) & 0xff))
    {
      s = t[s][c];

      if (s == -2)
	break;
      else if (s == -1)
	{
	  s = 0;
	  p = 0;
	}
      i++;
      p++;
    }

  /*   κп  ġǾ   accept ó κ
      ó  ⿡ ó ־ Ѵ.  */
  if (!c)
    {
      if(t[s][c] == -2)
	return i;
    }
  else if (s == -2)
    return i;
  
  return -1;
}

/* DFA ̺ Ҵ  ޸𸮸 Ѵ.  */
void
hre_free (dfa)
     hre_t dfa;
{
  int i;
  for (i=0; i < HDFA_INDEX (dfa); i++)
    free (HDFA_TABLE_N (dfa, i));

  free (HDFA_TABLE (dfa));
  free (dfa);
}

